/*
 * Source for loading/drawing image
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif
#include "trace.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkpixmap.h>

GtkWidget* gtk_pixmap_new_from_file( const char *filename )
{
  GtkWidget *result;
  GdkPixbuf *pixbuf;
  GdkPixmap *pixmap=NULL;
  GdkBitmap *mask=NULL;

  pixbuf = gdk_pixbuf_new_from_file( filename );
  if (!pixbuf)
   {
     trace( "Could not load `%s'!\n", filename );
     return NULL;
   }

  gdk_pixbuf_render_pixmap_and_mask( pixbuf, &pixmap, &mask, 127 );
  gdk_pixbuf_unref( pixbuf );

  result = gtk_pixmap_new( pixmap, mask );

  if (mask)
    gdk_bitmap_unref( mask );
  if (pixmap)
    gdk_pixmap_unref( pixmap );

  return result;
}


