/*
 * Source for loading/drawing images
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif
#include "image.h"
#include "trace.h"
#include <stdlib.h>
#include <stdio.h>
#include <SDL.h>
#if defined(HAVE_SDL_SDL_IMAGE_H)
#include <SDL/SDL_image.h>
#endif

SDL_Surface *
Image_Load(char *filename)
{
  int i;
  char tmp[1024];
  SDL_Surface *image, *image2;
  char *datadir_path[]=
   {
     STONAGE_DATA_DIR,
     ".",
     "../data",
     NULL
   };

  i=0; image=NULL;
  while (datadir_path[i])
   {
     snprintf(tmp,1024,"%s/%s",datadir_path[i],filename);
     trace("Trying to load %s",tmp);
#if defined(HAVE_SDL_SDL_IMAGE_H)
     image = IMG_Load(tmp);
#else
     image = SDL_LoadBMP(tmp);
#endif
     if (image)
       break;
     i++;
   }
  if (image==NULL)
   {
     fprintf(stderr,"Can't load this image %s\n",filename);
     return NULL;
   }
//  image2 = SDL_DisplayFormat(image);
//  SDL_FreeSurface(image);
  return image;
}

void Image_Free(SDL_Surface *img)
{
  if (img!=NULL)
   {
     SDL_FreeSurface(img);
   }
}

